function [pvaluebest,Jbest,sbest]=lmtest_bin(y,x,w,z,B,h,e,Tindex,nT,nS,qz,N,d,D)

pvaluebest=1;
Fbest=0;
sbest=[];
Jbest=[];
w=[];

%============================================%
%     Step 1 of the LM test (null model)     %
%============================================%

if nT==1
    Z=[ones(N,1) z w];
    k=size(Z,2);
    beta1=[];

%---------------------------------%    
%Incio Mtodo Newton-Raphson (H0)%
%---------------------------------%
for i=1:k
    b1(i)=0;
    beta1=b1';
end
    
R1=Z';
j=0;

while j < 10
    for i=1:N
        eta1=beta1'*R1(:,i);
        p1(i)=(exp(eta1))/(1+exp(eta1));
        q1=p1(i)*(1-p1(i));
        W1(i,:)=q1*Z(i,:);
    end
    H1=R1*W1;
    beta1=beta1+inv(R1*W1)*R1*(y-p1');
    j=j+1;
end    

    cutoff=0.5;
            for i=1:N
                if p1(:,i)>=cutoff;
                    y1_hat(i,:)=1;
                else
                    y1_hat(i,:)=0;
                end
            end
    u=y1_hat-p1';
    h=Z;
    
    %----------%
    %DEVIACE H0%
    %----------%
    for i=1:N
    if y1_hat(i,:)==0
       d0(i,:)=-2*log(1-p1(:,i));
    else
       d0(i,:)=-2*log(p1(:,i));
    end
    end
    D0=sum(d0(:));

else
    u=e;
    d0=d;
    D0=D;
end

%============================================%
%       Steps 2 and 3 of the LM test         %
%============================================%
nH0=size(h,2);

for o=1:nT
    for s=1:nS
        xsplit=x(:,s);
        
        if isempty(z)==0
            if sum(sum(repmat(xsplit,1,qz)==z,2))/N==1
                endog=1;
            else
                endog=0;
            end
        else
            endog=0;
        end
        if endog==0
            xsplit=repmat(xsplit,1,qz+1);
            zB=[ones(N,1) z].*repmat(B(:,o),1,qz+1);
            nu=[zB.*xsplit zB.*(xsplit.^2) zB.*(xsplit.^3)];
            nH1=size(nu,2);
        else
            xsplit=repmat(xsplit,1,qz);
            zB=z.*repmat(B(:,o),1,qz);
            nu=[zB.*xsplit zB.*(xsplit.^2) zB.*(xsplit.^3)];
            nH1=size(nu,2);
        end
        
        Z=[h nu];
        stdZ=[1 std(Z(:,2:size(Z,2)))];
        Z=Z./repmat(stdZ,size(Z,1),1);
        
        k=size(Z,2);
        clear beta2;
        beta2=[];
        

%---------------------------------%    
%Incio Mtodo Newton-Raphson (H1)%
%---------------------------------%
for i=1:k
    b2(i)=0;
    beta2=b2';
end
    
R2=Z';
j=0;
clear W2;
W2=[];

while j < 10
    for i=1:N
        eta2=beta2'*R2(:,i);
        p2(i)=(exp(eta2))/(1+exp(eta2));
        q2=p2(i)*(1-p2(i));
        W2(i,:)=q2*Z(i,:);
    end
    H2=R2*W2;
    beta2=beta2+inv(H2)*R2*(y-p2');
    j=j+1;
end

    cutoff=0.5;
       
        for i=1:N
            if p2(:,i)>=cutoff;
               y2_hat(i,:)=1;
            else
               y2_hat(i,:)=0;
            end
        end


%----------%
%DEVIACE H1%
%----------%
for i=1:N
if y2_hat(i,:)==0
   d1(i,:)=-2*log(1-p2(:,i));
else
   d1(i,:)=-2*log(p2(:,i));
end
end
D1=sum(d1(:));        
       
       F=((D0-D1)/nH1)/(D1/(N-nH0-nH1));
        pvalue=1-fcdf(F,nH1,N-nH0-nH1);
        if F>Fbest
            sbest=s;
            if isempty(Tindex)==1
                Jbest=0;
            else
                Jbest=Tindex(o);
            end
            pvaluebest=pvalue;
            Fbest=F;
        end
    end
end