%function [phi,B,yhat]=strgen_bin(X,y,x,w,z,Sindex,nT,nJ,n,qz,N)
function [phi,B,yhat,phat]=strgen_bin(X,y,x,w,z,Sindex,nT,nJ,n,qz,N)

g = X(1:nJ,1);
c = X(nJ+1:2*nJ,1);

% Generate the membership functions
% ---------------------------------
zB=[];
for i=1:nT
    B(:,i)=ones(N,1);
    for j=1:nJ
        G   = (logsigmoid_bin(g(j)*x(:,Sindex(j)),g(j)*c(j)));
        Gaux(:,j)=G;
        G_  = 1-G;
        n_1 = n(i,j)*(1+n(i,j))/2;
        n_2 = (1-n(i,j))*(1+n(i,j));
        B(:,i) = B(:,i).*((G.^n_1).*(G_.^n_2));
    end
    if isempty(z)==0
        zB = [zB z.*repmat(B(:,i),1,qz)];
    end
end
Z=[B zB];

% Estimate the linear coefficients
% --------------------------------
%phi=pinv(Z'*Z)*Z'*y;  %Medeiros (desmarcar para teste)n
%yhat=Z*phi; %Medeiros

%---------------------------------%    
%  Incio Mtodo Newton-Raphson   %
%---------------------------------%        
k=size(Z,2);

%for i=1:(k+1) %com intercepto
%    b(i)=0;
%    phi=b';
%end

for i=1:k
    b(i)=0;
    phi=b';
end

%for i=1:N
%    u(i)=1;
%end
%Z=[u' Z];

Rg=Z';
j=0;

while j < 10
    for i=1:N
        etag=phi'*Rg(:,i);
        pg(i)=(exp(etag))/(1+exp(etag));
        qg=pg(i)*(1-pg(i));
        Wg(i,:)=qg*Z(i,:);
    end
    Hg=Rg*Wg;
    phi=phi+inv(Rg*Wg)*Rg*(y-pg');
    j=j+1;
end


%while j < 8
%    for i=1:N
%        eta_aux=phi'*R(:,i);
%        p(i)=(exp(eta_aux))/(1+exp(eta_aux));
%        q=p(i)*(1-p(i));
%        W(i,:)=q*Z(i,:);
%    end
%    H=R*W;
%    phi=phi+inv(R*W)*R*(y-p');
%    j=j+1;
%end

%------------------------------%    
%  Fim Mtodo Newton-Raphson   %
%------------------------------%

%eta_hat=Z*phi;
%phat=exp(eta_hat)./(1+exp(eta_hat));
%cutoff=0.6;
%       for i=1:N
%            if phat(i,:)>=cutoff;
%               yhat(i,:)=1;
%            else
%               yhat(i,:)=0;
%            end
%        end

cutoff=0.5;
%phat=p';
phat=pg';
       for i=1:N
            if phat(i,:)>=cutoff;
               yhat(i,:)=1;
            else
               yhat(i,:)=0;
            end
        end       
        
        